{Asm2htm 2.1 (C) Pavel Holecek - 7software     }
{Toto je freeware.                             }
{http://7software.wz.cz/                       }

uses crt;

const klicslova:array[1..162] of string[7]=
      ('add',  'adc',  'inc',  'sub',  'sbb',  'rcl',  'sahf',  'jmp',
       'dec',  'cmp',  'neg',  'aaa',  'aas',  'ror',  'push',  'jcxz',
       'aam',  'aad',  'dda',  'das',  'mul',  'rol',  'pusha', 'loop',
       'imul', 'div',  'idiv', 'cbw',  'cwd',  'mov',  'pushf', 'loope',
       'and',  'test', 'or',   'xor',  'not',  'xchg', 'pop',   'loopz',
       'shl',  'sal',  'sar',  'shr',  'rcr',  'in',   'popa',  'loopne',
       'out',  'xlat', 'lea',  'lds',  'les',  'lahf', 'popf',  'loopnz',
       'ja',   'jnbe', 'jae',  'jnb',  'jb',   'jc',   'je',    'jz',
       'jg',   'jnge', 'jge',  'jnl',  'jl',   'jnge', 'jle',   'jng',
       'jnc',  'jne',  'jnz',  'jno',  'jnp',  'jpo',  'jns',   'jo',
       'jp',   'jpe',  'js',   'bound','enter','leave','int',   'into',
       'iret', 'clc',  'cmc',  'stc',  'cld',  'std',  'cli',   'sti',
       'clts', 'hlt',  'wait', 'fwait','lock', 'seg',  'cld',   'std',
       'rep',  'repe', 'repz', 'repne','repnz','movsb','movsw', 'lodsb',
       'lodsw','stosb','stosw','cmpsb','cmpsw','scasb','scasw', 'insb',
       'insw', 'outsb','outsw','lgdt', 'sgdt', 'lidt', 'sidt',  'lldt',
       'sldt', 'lmsw', 'smsw', 'ltr',  'str',  'lar',  'lsl',   'arpl',
       'ret',  'verr', 'bsf',  'bsr',  'bt',   'btc',  'btr',   'bts',
       'cdq',  'cmpsd','cwde', 'lfs',  'lgs',  'lss',  'movsx', 'movzx',
       'shld', 'shrd','cmpxchg','invd','invlpg','wbinvd','xadd',
       'call','rept','endm');
type tTagMap=array[1..4,1..2] of string[30];
const tagHlavicka=1;tagNormalni=2;tagKomentar=3;tagKlicove=4;
const TP_tag:ttagmap=(('<BODY bgcolor="blue"><PRE>','</PRE></BODY>'),
             ('<font color="yellow">','</font>'),
             ('<font color="gray">','</font>'),
             ('<font color="white">','</font>'));
const Delphi_tag:ttagmap=(('<BODY bgcolor="white"><PRE>','</PRE></BODY>'),
             ('<font color="black">','</font>'),
             ('<font color="gray"><i>','</i></font>'),
             ('<b>','</b>'));
var htmltag:ttagmap;
    radek:longint;ch:char;
var f,f1:text;
    s,s1,word:string;
    i,l:integer;
    bwrite:boolean;
    where:(Wnormal,Wstring,Wcomment);
function inttostr(i:longint):string;
var s:string;
begin
 str(i,s);
 inttostr:=s;
end;
function uppercase(s:string):string;
var i:integer;
begin
 for i:=1 to length(s) do s[i]:=upcase(s[i]);
 uppercase:=s;
end;
function iskeyword(s:string):boolean;
var i:integer;
begin
 iskeyword:=false;
  for i:=1 to 159 do if s=klicslova[i] then iskeyword:=true;
end;
begin
 if (paramcount<2) or (paramcount>3) then
 begin
  writeln('Asm2htm  verze 2.1  (C) Pavel Holeek - 7software');
  writeln(' Program pro prevod assemblerovskych zdrojaku do HTML.');
  writeln('Sintaxe : ASM2HTM soubor.asm soubor.htm [styl]');
  writeln('   soubor.asm ....... Soubor, ktery se ma zkonvertovat');
  writeln('   soubor.htm ....... Soubor, do ktereho prekonvertuje');
  writeln('   styl ............. Styl konverze. Bud zadate "PASCAL",');
  writeln('                      tim se pouzije styl Turbo Pascalu,');
  writeln('                      nebo zadate "DELPHI". Standartne');
  writeln('                      je pouzit styl Turbo Pascalu.');
  writeln;
  writeln('Priklad : Asm2htm zdrojak.Asm zdrojak.htm');
  writeln('          Asm2htm hra.Asm hra.htm delphi');
  halt;
 end;
 htmltag:=TP_tag;
 if paramcount>2 then if uppercase(paramstr(3))='DELPHI' then htmltag:=Delphi_tag;

 writeln('Asm2htm  verze 2.1  (C) Pavel Holeek - 7software');writeln;

 {$I-}assign(f,paramstr(1));reset(f);{$I+}
 if ioresult<>0 then
 begin
  writeln('Chyba pri otevirani souboru "'+paramstr(1)+'". Zkontrolujte, jestli  soubor existuje.');
  halt;
 end;
 {$I-}assign(f1,paramstr(2));reset(f1);close(f1);{$I+}
 if IOResult=0 then
 begin
  writeln('Souboru "'+paramstr(2)+'" jiz existuje.');
  write('Prepsat (a=ano,n=ne) : ');
  repeat ch:=readkey;until upcase(ch) in ['A','N'];
  if upcase(ch)='N' then begin writeln('ne.');halt;end;
  writeln('ano.');
 end;
 {$I-}assign(f1,paramstr(2));rewrite(f1);{$I+}
 if ioresult<>0 then
 begin
  writeln('Chyba pri vytvareni souboru "'+paramstr(2)+'".');
  halt;
 end;{$I-}
 writeln(f1,'<HTML>');
 writeln(f1,'<HEAD></HEAD>'+htmltag[tagHlavicka,1]);
 writeln(f1,htmltag[tagNormalni,1]);{$I+}
 if ioresult<>0 then begin writeln('Chyba pri zapisu do souboru "'+paramstr(2)+'".');halt;end;
 where:=Wnormal;

 radek:=0;writeln('Konvertuji '+paramstr(1)+' do '+paramstr(2)+'.');
 write('Pouzity styl : ');
 if paramcount>2 then if uppercase(paramstr(3))='DELPHI' then writeln('Delphi')
 else writeln('Turbo Pascal') else writeln('Turbo Pascal');
 writeln;
 write('Konvertuji ... 0. radek');
 while not eof(f) do
 begin
{$I-}readln(f,s);{$I+}
 if ioresult<>0 then begin writeln('Chyba pri cteni souboru "'+paramstr(1)+'".');halt;end;

  radek:=radek+1;
  gotoxy(16,wherey);write(inttostr(radek)+'. radek');
  s1:='';
  i:=1;
  while i<=length(s) do
  begin
   while (i<=length(s)) and (s[i] in[#9,' ',',','=',':','(',')',';','.','''','{','}','[',']','@']) do
   begin
    bwrite:=true;
    if (s[i]='<') then begin bwrite:=false;s1:=s1+'&lt;';end;
    if (s[i]='>') then begin bwrite:=false;s1:=s1+'&gt;';end;
    if (s[i]=';') and (where=wnormal) then begin where:=wcomment;s1:=s1+htmltag[tagKomentar,1];end;
    if s[i]='''' then
    begin
     if where=wnormal then where:=wstring else
     if where=wstring then where:=wnormal;
    end;
    if bwrite=true then s1:=s1+s[i];
    i:=i+1;
   end;
   while (i<=length(s)) and not (s[i] in[#9,' ',',','=',':','(',')',';','.','''','{','}','[',']','@']) do
   begin
    word:=word+s[i];
    i:=i+1;
   end;
   if word<>'' then
   begin
    if (iskeyword(word)) and (where=wnormal) then
                         s1:=s1+htmltag[tagKlicove,1]+word+htmltag[tagKlicove,2]
     else s1:=s1+word;
    word:='';
   end;
  end;
  if (where=wcomment) then begin where:=wnormal;bwrite:=false;s1:=s1+htmltag[tagKomentar,2];end;
  writeln(f1,s1);
 end;
 close(f);
 writeln(f1,htmltag[tagNormalni,2]);
 writeln(f1,htmltag[tagHlavicka,2]);
 writeln(f1,'</HTML>');
 close(f1);
 gotoxy(16,wherey);writeln('hotovo.         ');
end.